/***********************************************
 * S. 92.                                      *
 * Németh 123 Balázs 9.c                       *
 * Budapesti Fazekas Mihály Ált. Isk. és Gimn. *
 * nemethbalazs2000@gmail.com                  *
 * g++ 4.8.2                                   *
 **********************************************/ 

#include <cstdio>
#include <set>
#include <utility>

using namespace std;

struct cmp // összehasonlító struktúra
{
	bool operator() (const pair<int, int>& p, const pair<int, int>& q) const {return p.first<q.first;} // a párokat az első tagjuk alapján hasonlítjuk össze, a második tag nem érdekes
};

unsigned int n, k; // N és K a feladatból
pair<int, int> a[2000000]; // a bemeneti számok
set<pair<int, int>, cmp> s; // az algoritmus során használt halmaz

int main(int argc, char **argv)
{	
	scanf("%d %d", &n, &k); // N és K beolvasása
	
	int j = 0;
	int t;
	
	scanf("%d", &t); // az első szám beolvasása és pár készítése
	a[j++] = make_pair(t, 1);
	
	for (unsigned int i = 1; i < n; ++i)
	{
		scanf("%d", &t);
		
		if (t == a[j].first) // ha az előző számmal egyezik meg
			a[j].second++;   // növeljük a darabszámot
		else
			a[j++] = make_pair(t, 1); // egyébként új párt készítünk
	}
	
	pair<set<pair<int, int>, cmp>::iterator, bool> r; // a halmazba való beszúrás eredménye
	set<pair<int, int>, cmp>::iterator it; // a halmazban való keresés eredménye
	int m = 0; // m a maximum
	int o = 0; // o az intervallum kezdőindexe
	int l = 0; // l az intervallum végindexe
	
	while (l < j)
	{
		if (s.size() <= k+1) // mivel a halmaz elemszáma kisebb vagy egyenlő K+1-nél, így hozzáadunk a halmazhoz
		{
			r = s.insert(a[l]);
			
			if (!r.second) // ez esetben a hozzáadás nem sikerült, mert a[l] már megtalálható a halmazban
			{
				*(const_cast<int*>(&(r.first->second))) += a[l].second; // így az a[l] szám darabszámát megnöveljük annyival, 

				if (m < r.first->second) // összehasonlítjuk a halmazban megtalált pár darabszámát az eddigi legnagyobbal
					m = r.first->second;
			}
			else // ez esetben sikerült a beszúrás
			{
				if (m < a[l].second) // megint egy maximumfrissítés
					m = a[l].second;
			}
			
			l++; // kitoljuk a végindexet
		}
		else // most a halmaz elejéről veszünk el
		{
			it = s.find(a[o]); // megkeressük az a[o]. elemet
			
			*(const_cast<int*>(&(it->second))) -= a[o++].second; // levonjuk a darabszámot, hiszen elveszünk a halmazból
			
			if (it->second == 0) // ha már nem maradt belőle, kitöröljük
				s.erase(it);
		}
	}
	
	
	printf("%d\n", m); // kiírás
}
